import os
import openai
import random
import numpy as np
import json
import jsonlines
import time
from tqdm import tqdm
from rank_bm25 import BM25Okapi
import threading

# OPENAI_API_KEY = "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"
# OPENAI_API_KEY = "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"
OPENAI_API_KEY = "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"
openai.api_key = OPENAI_API_KEY

def ask_gpt4(question, thread_id, file_lock, line):
    messages=[{"role": "user", "content": question}]
    while True:
        try:
            response =  openai.ChatCompletion.create(
                            model="gpt-4",
                            max_tokens=1000,
                            temperature=1.2,
                            messages = messages)
            answer = response["choices"][0]["message"]["content"]

            with file_lock:
                with open('./gpt4_ans/winogavil/anscom/swow/test.jsonl','a') as outfile:
                    line['gpt4_rate'] = answer
                    outfile.write(json.dumps(line) + "\n")
                    break

        except openai.error.RateLimitError: # Rate limit exceeded
            time.sleep(0.2)
        except openai.error.Timeout: # Rate limit exceeded
            time.sleep(0.2)
        except openai.error.OpenAIError:
            raise Exception("Sorry, a problem happened")
        

def read_jsonline(sample_file):
    samples = []
    for line in sample_file.iter():
        sample = '''The option A: %s''' %(str(line['captions']))
        samples.append(sample)
    return samples
        
if __name__=="__main__":
    caption_file = jsonlines.open('./data/winogavil/random_icl/swow/test.jsonl')
    explanation_file = jsonlines.open('./data/winogavil/cb_icl/swow/test.jsonl')
    corpus = read_jsonline(caption_file)
    file_lock = threading.Lock()
    threads = []
    with tqdm(desc='Process', unit='it', total=84) as pbar: #5_6: (260); 10_12: (85); swow: (84)
        num = 0
        for line in explanation_file.iter():
            option_a = corpus[num]
            cue = line['cue']
            labels = line['labels']
            k = np.count_nonzero(labels)
            option_b = '''The option B: %s''' %(str(line['explanations']))
            start_prompt = '''Evaluate the equivalence of the following two captions list for the question "choose the top %d sentences most related to the cue %s from captions?" ''' %(k, cue)
            middle_prompt = '''%s; %s''' %(option_a, option_b)
            last_prompt = ''' Please answer with True if option B provide more useful information to predict answer compared with option A, Answer with False if option A provide more useful information to predict answer compared with option B. Answer Equal if they provide same useful information to answer question.'''
            end_prompt = '''Please only return True, False or Equal.'''
            content = f'''{start_prompt}{middle_prompt}{last_prompt}{end_prompt}'''
            thread = threading.Thread(target=ask_gpt4, args=(content, num+1, file_lock, line))
            threads.append(thread)
            thread.start()
            num = num+1
            pbar.update()

        for thread in threads:
            thread.join()
















