import os
import openai
import random
import numpy as np
import json
import jsonlines
import time
from tqdm import tqdm
from rank_bm25 import BM25Okapi

# OPENAI_API_KEY = "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"
OPENAI_API_KEY = "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"
openai.api_key = OPENAI_API_KEY

start_prompt = '''
You need to pick up some sentences from a list of captions most related to given cue. Here are five examples.
'''


def ask_gpt4(question):
    messages=[{"role": "user", "content": question}]
    while True:
        try:
            response =  openai.ChatCompletion.create(
                            model="gpt-4",
                            max_tokens=1000,
                            temperature=1.2,
                            messages = messages)
            answer = response["choices"][0]["message"]["content"]
            return answer
        except openai.error.RateLimitError: # Rate limit exceeded
            time.sleep(0.2)
        except openai.error.Timeout: # Rate limit exceeded
            time.sleep(0.2)
        except openai.error.OpenAIError:
            raise Exception("Sorry, a problem happened")
        
def read_jsonline(sample_file):
    samples = []
    for line in sample_file.iter():
        sample = "The given cue is %s, the selected number of case is %d, and the captions %s. The corresponding correct labels are %s" %(line['cue'], np.count_nonzero(line['labels']), str(line['captions']), line['labels'])
        samples.append(sample)
    return samples
        

if __name__=="__main__":
    dataset = jsonlines.open('./data/winogavil/similar_icl/swow/test.jsonl')
    sample_file = jsonlines.open('./data/winogavil/similar_icl/swow/train.jsonl')
    corpus = read_jsonline(sample_file)
    tokenized_corpus = [doc.split(" ") for doc in corpus]   
    bm25 = BM25Okapi(tokenized_corpus)
    with tqdm(desc='Process', unit='it', total=84) as pbar: #5_6: (260); 10_12: (85); swow: (84)
        with open('./gpt4_ans/winogavil/similar_icl/swow/test.jsonl','a') as outfile:
            num = 1 # this used to fix connection error problem 
            for line in dataset.iter():
                if num > 0: #start from 1 to reord, once code stop in middle, change number to the stop point
                    captions = line['captions']
                    cue = line['cue']
                    labels = line['labels']
                    k = np.count_nonzero(labels)
                    query = "Now choose the top %d sentences most related to the cue %s from captions: %s." % (k, cue, str(captions))
                    tokenized_query = query.split(" ")
                    doc_scores = bm25.get_scores(tokenized_query)
                    scored_sentences = list(zip(corpus, doc_scores))
                    sorted_scored_sentences = sorted(scored_sentences, key=lambda x: x[1], reverse=True)
                    top_5_sentences = [sentence[0] for sentence in sorted_scored_sentences[:5]]
                    samples_prompt = ''''''
                    for sentence in top_5_sentences:
                        sample_prompt = '''%s''' %(sentence)
                        samples_prompt = f'''{samples_prompt}{sample_prompt}'''
                    Question_part1 = '''\nNow choose the top %d sentences most related to the cue %s from captions: %s. ''' % (k, cue, str(captions))
                    Question_part2 = '''Directly return the %d sentences as answer.''' %(k)
                    content = f'''{start_prompt}{samples_prompt}{Question_part1}{Question_part2}'''
                    answer = ask_gpt4(content)
                    information = {}
                    information['images'] = line['images']
                    information['cue'] = line['cue']
                    information['labels'] = line['labels']
                    information['captions'] = line['captions']
                    information['gpt4'] = answer
                    json.dump(information, outfile)
                    outfile.write('\n')
                pbar.update()
                num = num + 1


                    






